golang beego框架对运行异常的处理

运行时异常

panic

在通常情况下,函数向其调用方报告错误的方式都是返回一个error类型的值。但是当遇到致命错误的时候,很可能会使程序无法继续运行。Go推荐通过调用panic函数来报告致命错误,它会停止当前控制流程,并引发一个运行时恐慌。例如:

package main

import "errors"

func main() {
	outerFunc()
}

func outerFunc() {
	innerFunc()
}

func innerFunc() {
	panic(errors.New("an intended fatal error"))
}

程序执行后的结果为:

D:\gotest>go run main.go
panic: an intended fatal error

goroutine 1 [running]:
main.innerFunc(...)
        D:/gotest/main.go:14
main.outerFunc(...)
        D:/gotest/main.go:10
main.main()
        D:/gotest/main.go:6 +0x77
exit status 2

当调用innerFunc函数中的panic函数后,innerFunc的执行会被停止。紧接着,流程控制权会交给调用方outerFunc函数。然后,outerFunc函数的执行也会停止。运行时恐慌就沿着调用栈反方向进行传播,直至到达当前goroutine的调用栈的最顶层。一旦达到顶层,就意味着该goroutine调用栈中所有函数的执行都已经被停止了,程序已经崩溃。
当然,运行时恐慌并不都是通过调用panic函数的方式引发,也可以由Go的运行时系统来引发。例如发生像数组下标越界或类型断言失败这样的运行错误时,Go运行时会触发运行时panic

recover

为了避免恐慌造成的程序崩溃。Go提供了专用于"拦截"运行时恐慌的内建函数recover,它可以使当前的程序从恐慌状态中恢复并重新获得流程控制权。recover函数被调用后,会返回一个interface{}类型的结果。如果当时的程序正处于运行时恐慌的状态,那么这个结果就会是非nil的。使用方法:

defer func() {
    if p := recover(); p != nil {
        fmt.Printf("Recovered panic: %s\n", p)
    }
}()

beego框架的处理

beego框架有一些初始化的函数,当你引用beego框架时,也就同时执行了初始化函数。(有关包的初始化,可以点击Go init函数详解进行查看)。其中beego\config.go文件中的init函数涉及到了程序对panic的处理。

func init () {
    BConfig = newBconfig()
    // ...
}

func newBConfig() *Config {
    return &Config{
        AppName:                "beego",
        RunMode:                DEV,
        RouterCaseSensitive:    true,
        ServerName:             "beegoServer:" + VERSION,
        RecoverPanic:           true,
        RecoverFunc:            recoverPanic,
        //...
    }
}

func recoverPanic(ctx *context.Context) {
    if err := recover(); err != nil {
        if err == ErrAbort {
            return
        }
        if !BConfig.RecoverPanic {
            panic(err)
        }
        if BConfig.EnableErrorsShow {
            if _,ok := ErrorMaps[fmt.Sprint(err)]; ok {
                exception(fmt.Sprint(err),ctx)
                return
            }
        }
        var stack string
        logs.Critical("the request url is ", ctx.Input.URL())
        logs.Critical(""Handler crashed with error", err)
        for i := 1; ; i++ {
            _, file, line, ok := runtime.Caller(i)
            if !ok {
                break
            }
            logs.Critical(fmt.Sprintf("%s:%d", file, line))
            stack = stack + fmt.Sprintln(fmt.Sprintf("%s:%d", file, line))
        }
        if BConfig.RunMode == DEV || BConfig.EnableErrorsRender {
            showErr(err, ctx, stack)
        }
    }
}

从上面的代码我们可以看到,使用beego框架启动程序时,会初始化一个recoverPanic方法。当程序遇到异常时,会进行异常恢复,防止程序崩溃。
beegorunmode模式为dev,且EnableErrorsRender(是否将错误信息进行渲染,默认值为true,即出错会提示友好的出错页面,对于API类型的应用,可能需要将该选项设置为false,以防止在dev模式下不必要的模板渲染信息返回)为true的情况下,会在前端将异常展示出来。而对于其他模式,beego只会在控制台将panic出现的调用栈信息依次打印出来。

 

发布了57 篇原创文章 · 获赞 537 · 访问量 485万+
展开阅读全文

没有更多推荐了,返回首页

©️2019 CSDN 皮肤主题: 编程工作室 设计师: CSDN官方博客

分享到微信朋友圈

×

扫一扫,手机浏览